<?php
/*
Plugin Name: Nike+iPod Stats
Description: Shows your running stats on the sidebar
Author: Laura Zavala
Version: 2.0
Author URI: http://blog.laurazavala.com


    Copyright (C) 2008  Laura Zavala  (zavala.usc@gmail.com)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// Required plugin functions
function widget_nikeplusipod_init() {

	//to make sure widgets are enabled 
	if ( !function_exists('register_sidebar_widget') )
		return;

	// Creates the main function and gets variable values to use later
	function widget_nikeplusipod($args) {
		
	  	// $args is an array of strings that help widgets to conform to
		// the active theme: before_widget, before_title, after_widget,
		// and after_title are the array keys. 
		extract($args);

		// nike+ipod widget options
		$options = get_option('widget_nikeplusipod');
		$title = $options['title'];
		$userid = $options['userid'];

		// to make sure title is set
		if(empty($title)) {        		  
                        $title = "NikePlus Stats";
    		}

		// These lines generate output to the screen
		echo '<p>' . $before_widget . $before_title . $title . $after_title;

		// to make sure userid is set
		if(empty($userid)) {        		  
                        echo "You need to enter your userID";
    		}
	    	else {	
                        //gets the data from the nikeplus site
                        $runid=0;
                        $goalid=0;
        		$url_userprofile = 'http://nikeplus.nike.com/nikeplus/v1/services/app/get_public_user_data.jsp?id='.$userid;                       
        		$url_run_list = 'http://nikeplus.nike.com/nikeplus/v1/services/app/get_public_run_list.jsp?id='.$userid; 
        		$url_run = 'http://nikeplus.nike.com/nikeplus/v1/services/app/get_public_run.jsp?id='. $runid. '&userID='.$userid; 
                        $url_goal_list = 'http://nikeplus.nike.com/nikeplus/v1/services/app/goal_list.jsp?userID='.$userid; 
                       $url_goal = 'http://nikeplus.nike.com/nikeplus/v1/services/app/get_public_goal.jsp?id=' .$goalid.'&userID='.$userid; 
                        $url_farthest_run = 'http://nikeplus.nike.com/nikeplus/v1/services/app/get_public_farthest_run.jsp?id='.$userid; 
                        $url_fastest_run = 'http://nikeplus.nike.com/nikeplus/v1/services/app/get_public_fastest_run.jsp?id='.$userid; 

                        display_xsl($url_userprofile, '/nikeplusipod_profile.xsl');
                        display_xsl($url_run_list, '/nikeplusipod_runs.xsl');
                        display_xsl($url_farthest_run, '/nikeplusipod_farthest.xsl');
                        display_xsl($url_fastest_run, '/nikeplusipod_fastest.xsl');
              }
              echo $after_widget . '</p>';
	}

	function display_xsl($url, $xslfile) {
        		$ch = curl_init();
      	                curl_setopt($ch, CURLOPT_URL, $url);
	                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                        $output = curl_exec($ch);
      	                curl_close($ch);

                        //applies style and displays info
        		$xsl = new DomDocument();
		        $xsl->load(ABSPATH.'wp-content/plugins/'.dirname(plugin_basename(__FILE__)) . $xslfile);        		
        		$proc = new XsltProcessor();
                        $xsl = $proc->importStylesheet($xsl);
                        $inputdom = new DomDocument();
                        $inputdom->loadXML($output);
                        $newdom = new DomDocument();
                        $newdom = $proc->transformToDoc($inputdom);
                        print $newdom->saveHTML();
        }

	// Function for displaying the edit form in the admin widgets page
	function widget_nikeplusipod_control() {

                // Get options
		$options = get_option('widget_nikeplusipod');
                // options exist? if not set defaults
		if ( !is_array($options) )
			$options = array('title'=>'NikePlus Stats', 'userid'=>'');
                // to post the form
		if ( $_POST['nike-submit'] ) {
			$options['title'] = strip_tags(stripslashes($_POST['nike-title']));
			$options['userid'] = strip_tags(stripslashes($_POST['nike-userid']));
			update_option('widget_nikeplusipod', $options);
		}

		// Get options for form fields to show
		$title = htmlspecialchars($options['title'], ENT_QUOTES);
		$userid = htmlspecialchars($options['userid'], ENT_QUOTES);
		
		// The form fields
		echo '<p style="text-align:right;">
                  <label for="nike-title">' . __('Title:') . ' <input style="width: 200px;" id="nike-title" name="nike-title" type="text" value="'.$title.'" /></label></p>';
		echo '<p style="text-align:right;">
                  <label for="nike-userid">' . __('User ID:') . ' <input style="width: 200px;" id="nike-userid" name="nike-userid" type="text" value="'.$userid.'" /></label></p>';
		echo '<input type="hidden" id="nike-submit" name="nike-submit" value="1" />';
	}
	
	// to register this widget 
	register_sidebar_widget(array('Nike Plus Stats', 'widgets'), 'widget_nikeplusipod');

	// This registers our optional widget control form. 
	register_widget_control(array('Nike Plus Stats', 'widgets'), 'widget_nikeplusipod_control', 300, 200);
}

// Run our code later in case this loads prior to any required plugins.
add_action('widgets_init', 'widget_nikeplusipod_init');

?>
